Loading...
Searching...
No Matches
des.h File Reference

DES block cipher. More...

`#include "mbedtls/private_access.h"`
`#include "mbedtls/build_info.h"`
`#include "mbedtls/platform_util.h"`
`#include <stddef.h>`
`#include <stdint.h>`
Include dependency graph for des.h:

Go to the source code of this file.

## Data Structures

struct | mbedtls_des_context
| DES context structure. More...
struct | mbedtls_des3_context
| Triple-DES context structure. More...

## Macros

#define | MBEDTLS_DES_ENCRYPT 1
#define | MBEDTLS_DES_DECRYPT 0
#define | MBEDTLS_ERR_DES_INVALID_INPUT_LENGTH -0x0032
#define | MBEDTLS_DES_KEY_SIZE 8

## Typedefs

typedef struct mbedtls_des_context | mbedtls_des_context
| DES context structure.
typedef struct mbedtls_des3_context | mbedtls_des3_context
| Triple-DES context structure.

## Functions

void | mbedtls_des_init (mbedtls_des_context *ctx)
| Initialize DES context.
void | mbedtls_des_free (mbedtls_des_context *ctx)
| Clear DES context.
void | mbedtls_des3_init (mbedtls_des3_context *ctx)
| Initialize Triple-DES context.
void | mbedtls_des3_free (mbedtls_des3_context *ctx)
| Clear Triple-DES context.
void | mbedtls_des_key_set_parity (unsigned char key[MBEDTLS_DES_KEY_SIZE])
| Set key parity on the given key to odd.
int | mbedtls_des_key_check_key_parity (const unsigned char key[MBEDTLS_DES_KEY_SIZE])
| Check that key parity on the given key is odd.
int | mbedtls_des_key_check_weak (const unsigned char key[MBEDTLS_DES_KEY_SIZE])
| Check that key is not a weak or semi-weak DES key.
int | mbedtls_des_setkey_enc (mbedtls_des_context *ctx, const unsigned char key[MBEDTLS_DES_KEY_SIZE])
| DES key schedule (56-bit, encryption).
int | mbedtls_des_setkey_dec (mbedtls_des_context *ctx, const unsigned char key[MBEDTLS_DES_KEY_SIZE])
| DES key schedule (56-bit, decryption).
int | mbedtls_des3_set2key_enc (mbedtls_des3_context *ctx, const unsigned char key[MBEDTLS_DES_KEY_SIZE *2])
| Triple-DES key schedule (112-bit, encryption).
int | mbedtls_des3_set2key_dec (mbedtls_des3_context *ctx, const unsigned char key[MBEDTLS_DES_KEY_SIZE *2])
| Triple-DES key schedule (112-bit, decryption).
int | mbedtls_des3_set3key_enc (mbedtls_des3_context *ctx, const unsigned char key[MBEDTLS_DES_KEY_SIZE *3])
| Triple-DES key schedule (168-bit, encryption).
int | mbedtls_des3_set3key_dec (mbedtls_des3_context *ctx, const unsigned char key[MBEDTLS_DES_KEY_SIZE *3])
| Triple-DES key schedule (168-bit, decryption).
int | mbedtls_des_crypt_ecb (mbedtls_des_context *ctx, const unsigned char input[8], unsigned char output[8])
| DES-ECB block encryption/decryption.
int | mbedtls_des_crypt_cbc (mbedtls_des_context *ctx, int mode, size_t length, unsigned char iv[8], const unsigned char *input, unsigned char *output)
| DES-CBC buffer encryption/decryption.
int | mbedtls_des3_crypt_ecb (mbedtls_des3_context *ctx, const unsigned char input[8], unsigned char output[8])
| 3DES-ECB block encryption/decryption
int | mbedtls_des3_crypt_cbc (mbedtls_des3_context *ctx, int mode, size_t length, unsigned char iv[8], const unsigned char *input, unsigned char *output)
| 3DES-CBC buffer encryption/decryption
void | mbedtls_des_setkey (uint32_t SK[32], const unsigned char key[MBEDTLS_DES_KEY_SIZE])
| Internal function for key expansion. (Only exposed to allow overriding it, see MBEDTLS_DES_SETKEY_ALT).
int | mbedtls_des_self_test (int verbose)
| Checkup routine.

## Detailed Description

DES block cipher.

Warning
  DES/3DES are considered weak ciphers and their use constitutes a security risk. We recommend considering stronger ciphers instead.

Definition in file des.h.

## Macro Definition Documentation

## MBEDTLS_DES_DECRYPT

#define MBEDTLS_DES_DECRYPT 0

Definition at line 26 of file des.h.

## MBEDTLS_DES_ENCRYPT

#define MBEDTLS_DES_ENCRYPT 1

Definition at line 25 of file des.h.

## MBEDTLS_DES_KEY_SIZE

#define MBEDTLS_DES_KEY_SIZE 8

Definition at line 31 of file des.h.

Referenced by mbedtls_des3_set2key_dec(), mbedtls_des3_set2key_enc(), mbedtls_des3_set3key_dec(), mbedtls_des3_set3key_enc(), mbedtls_des_key_check_key_parity(), mbedtls_des_key_check_weak(), mbedtls_des_key_set_parity(), mbedtls_des_setkey(), mbedtls_des_setkey_dec(), and mbedtls_des_setkey_enc().

## MBEDTLS_ERR_DES_INVALID_INPUT_LENGTH

#define MBEDTLS_ERR_DES_INVALID_INPUT_LENGTH -0x0032

The data input has an invalid length.

Definition at line 29 of file des.h.

## Typedef Documentation

## mbedtls_des3_context

typedef struct mbedtls_des3_context mbedtls_des3_context

Triple-DES context structure.

Warning
  DES/3DES are considered weak ciphers and their use constitutes a security risk. We recommend considering stronger ciphers instead.

## mbedtls_des_context

typedef struct mbedtls_des_context mbedtls_des_context

DES context structure.

Warning
  DES/3DES are considered weak ciphers and their use constitutes a security risk. We recommend considering stronger ciphers instead.

## Function Documentation

## mbedtls_des3_crypt_cbc()

int mbedtls_des3_crypt_cbc | ( | mbedtls_des3_context * | ctx,
|  | int | mode,
|  | size_t | length,
|  | unsigned char | iv[8],
|  | const unsigned char * | input,
|  | unsigned char * | output )

3DES-CBC buffer encryption/decryption

Note
  Upon exit, the content of the IV is updated so that you can call the function same function again on the following block(s) of data and get the same result as if it was encrypted in one call. This allows a "streaming" usage. If on the other hand you need to retain the contents of the IV, you should either save it manually or use the cipher module instead.

Parameters

  ctx | 3DES context
  mode | MBEDTLS_DES_ENCRYPT or MBEDTLS_DES_DECRYPT
  length | length of the input data
  iv | initialization vector (updated after use)
  input | buffer holding the input data
  output | buffer holding the output data

Returns
  0 if successful, or MBEDTLS_ERR_DES_INVALID_INPUT_LENGTH

Warning
  DES/3DES are considered weak ciphers and their use constitutes a security risk. We recommend considering stronger ciphers instead.

## mbedtls_des3_crypt_ecb()

int mbedtls_des3_crypt_ecb | ( | mbedtls_des3_context * | ctx,
|  | const unsigned char | input[8],
|  | unsigned char | output[8] )

3DES-ECB block encryption/decryption

Parameters

  ctx | 3DES context
  input | 64-bit input block
  output | 64-bit output block

Returns
  0 if successful

Warning
  DES/3DES are considered weak ciphers and their use constitutes a security risk. We recommend considering stronger ciphers instead.

References MBEDTLS_CHECK_RETURN_TYPICAL.

## mbedtls_des3_free()

void mbedtls_des3_free | ( | mbedtls_des3_context * | ctx | ) |

Clear Triple-DES context.

Parameters

  ctx | DES3 context to be cleared

Warning
  DES/3DES are considered weak ciphers and their use constitutes a security risk. We recommend considering stronger ciphers instead.

## mbedtls_des3_init()

void mbedtls_des3_init | ( | mbedtls_des3_context * | ctx | ) |

Initialize Triple-DES context.

Parameters

  ctx | DES3 context to be initialized

Warning
  DES/3DES are considered weak ciphers and their use constitutes a security risk. We recommend considering stronger ciphers instead.

## mbedtls_des3_set2key_dec()

int mbedtls_des3_set2key_dec | ( | mbedtls_des3_context * | ctx,
|  | const unsigned char | key[MBEDTLS_DES_KEY_SIZE *2] )

Triple-DES key schedule (112-bit, decryption).

Parameters

  ctx | 3DES context to be initialized
  key | 16-byte secret key

Returns
  0

Warning
  DES/3DES are considered weak ciphers and their use constitutes a security risk. We recommend considering stronger ciphers instead.

References MBEDTLS_CHECK_RETURN_TYPICAL, and MBEDTLS_DES_KEY_SIZE.

## mbedtls_des3_set2key_enc()

int mbedtls_des3_set2key_enc | ( | mbedtls_des3_context * | ctx,
|  | const unsigned char | key[MBEDTLS_DES_KEY_SIZE *2] )

Triple-DES key schedule (112-bit, encryption).

Parameters

  ctx | 3DES context to be initialized
  key | 16-byte secret key

Returns
  0

Warning
  DES/3DES are considered weak ciphers and their use constitutes a security risk. We recommend considering stronger ciphers instead.

References MBEDTLS_CHECK_RETURN_TYPICAL, and MBEDTLS_DES_KEY_SIZE.

## mbedtls_des3_set3key_dec()

int mbedtls_des3_set3key_dec | ( | mbedtls_des3_context * | ctx,
|  | const unsigned char | key[MBEDTLS_DES_KEY_SIZE *3] )

Triple-DES key schedule (168-bit, decryption).

Parameters

  ctx | 3DES context to be initialized
  key | 24-byte secret key

Returns
  0

Warning
  DES/3DES are considered weak ciphers and their use constitutes a security risk. We recommend considering stronger ciphers instead.

References MBEDTLS_CHECK_RETURN_TYPICAL, and MBEDTLS_DES_KEY_SIZE.

## mbedtls_des3_set3key_enc()

int mbedtls_des3_set3key_enc | ( | mbedtls_des3_context * | ctx,
|  | const unsigned char | key[MBEDTLS_DES_KEY_SIZE *3] )

Triple-DES key schedule (168-bit, encryption).

Parameters

  ctx | 3DES context to be initialized
  key | 24-byte secret key

Returns
  0

Warning
  DES/3DES are considered weak ciphers and their use constitutes a security risk. We recommend considering stronger ciphers instead.

References MBEDTLS_CHECK_RETURN_TYPICAL, and MBEDTLS_DES_KEY_SIZE.

## mbedtls_des_crypt_cbc()

int mbedtls_des_crypt_cbc | ( | mbedtls_des_context * | ctx,
|  | int | mode,
|  | size_t | length,
|  | unsigned char | iv[8],
|  | const unsigned char * | input,
|  | unsigned char * | output )

DES-CBC buffer encryption/decryption.

Note
  Upon exit, the content of the IV is updated so that you can call the function same function again on the following block(s) of data and get the same result as if it was encrypted in one call. This allows a "streaming" usage. If on the other hand you need to retain the contents of the IV, you should either save it manually or use the cipher module instead.

Parameters

  ctx | DES context
  mode | MBEDTLS_DES_ENCRYPT or MBEDTLS_DES_DECRYPT
  length | length of the input data
  iv | initialization vector (updated after use)
  input | buffer holding the input data
  output | buffer holding the output data

Warning
  DES/3DES are considered weak ciphers and their use constitutes a security risk. We recommend considering stronger ciphers instead.

References MBEDTLS_CHECK_RETURN_TYPICAL.

## mbedtls_des_crypt_ecb()

int mbedtls_des_crypt_ecb | ( | mbedtls_des_context * | ctx,
|  | const unsigned char | input[8],
|  | unsigned char | output[8] )

DES-ECB block encryption/decryption.

Parameters

  ctx | DES context
  input | 64-bit input block
  output | 64-bit output block

Returns
  0 if successful

Warning
  DES/3DES are considered weak ciphers and their use constitutes a security risk. We recommend considering stronger ciphers instead.

References MBEDTLS_CHECK_RETURN_TYPICAL.

## mbedtls_des_free()

void mbedtls_des_free | ( | mbedtls_des_context * | ctx | ) |

Clear DES context.

Parameters

  ctx | DES context to be cleared

Warning
  DES/3DES are considered weak ciphers and their use constitutes a security risk. We recommend considering stronger ciphers instead.

## mbedtls_des_init()

void mbedtls_des_init | ( | mbedtls_des_context * | ctx | ) |

Initialize DES context.

Parameters

  ctx | DES context to be initialized

Warning
  DES/3DES are considered weak ciphers and their use constitutes a security risk. We recommend considering stronger ciphers instead.

## mbedtls_des_key_check_key_parity()

int mbedtls_des_key_check_key_parity | ( | const unsigned char | key[MBEDTLS_DES_KEY_SIZE] | ) |

Check that key parity on the given key is odd.

               DES keys are 56 bits long, but each byte is padded with
               a parity bit to allow verification.

Parameters

  key | 8-byte secret key

Returns
  0 is parity was ok, 1 if parity was not correct.

Warning
  DES/3DES are considered weak ciphers and their use constitutes a security risk. We recommend considering stronger ciphers instead.

References MBEDTLS_CHECK_RETURN_TYPICAL, and MBEDTLS_DES_KEY_SIZE.

## mbedtls_des_key_check_weak()

int mbedtls_des_key_check_weak | ( | const unsigned char | key[MBEDTLS_DES_KEY_SIZE] | ) |

Check that key is not a weak or semi-weak DES key.

Parameters

  key | 8-byte secret key

Returns
  0 if no weak key was found, 1 if a weak key was identified.

Warning
  DES/3DES are considered weak ciphers and their use constitutes a security risk. We recommend considering stronger ciphers instead.

References MBEDTLS_CHECK_RETURN_TYPICAL, and MBEDTLS_DES_KEY_SIZE.

## mbedtls_des_key_set_parity()

void mbedtls_des_key_set_parity | ( | unsigned char | key[MBEDTLS_DES_KEY_SIZE] | ) |

Set key parity on the given key to odd.

               DES keys are 56 bits long, but each byte is padded with
               a parity bit to allow verification.

Parameters

  key | 8-byte secret key

Warning
  DES/3DES are considered weak ciphers and their use constitutes a security risk. We recommend considering stronger ciphers instead.

References MBEDTLS_CHECK_RETURN_TYPICAL, and MBEDTLS_DES_KEY_SIZE.

## mbedtls_des_self_test()

int mbedtls_des_self_test | ( | int | verbose | ) |

Checkup routine.

Returns
  0 if successful, or 1 if the test failed

## mbedtls_des_setkey()

void mbedtls_des_setkey | ( | uint32_t | SK[32],
|  | const unsigned char | key[MBEDTLS_DES_KEY_SIZE] )

Internal function for key expansion. (Only exposed to allow overriding it, see MBEDTLS_DES_SETKEY_ALT).

Parameters

  SK | Round keys
  key | Base key

Warning
  DES/3DES are considered weak ciphers and their use constitutes a security risk. We recommend considering stronger ciphers instead.

References MBEDTLS_CHECK_RETURN_CRITICAL, and MBEDTLS_DES_KEY_SIZE.

## mbedtls_des_setkey_dec()

int mbedtls_des_setkey_dec | ( | mbedtls_des_context * | ctx,
|  | const unsigned char | key[MBEDTLS_DES_KEY_SIZE] )

DES key schedule (56-bit, decryption).

Parameters

  ctx | DES context to be initialized
  key | 8-byte secret key

Returns
  0

Warning
  DES/3DES are considered weak ciphers and their use constitutes a security risk. We recommend considering stronger ciphers instead.

References MBEDTLS_CHECK_RETURN_TYPICAL, and MBEDTLS_DES_KEY_SIZE.

## mbedtls_des_setkey_enc()

int mbedtls_des_setkey_enc | ( | mbedtls_des_context * | ctx,
|  | const unsigned char | key[MBEDTLS_DES_KEY_SIZE] )

DES key schedule (56-bit, encryption).

Parameters

  ctx | DES context to be initialized
  key | 8-byte secret key

Returns
  0

Warning
  DES/3DES are considered weak ciphers and their use constitutes a security risk. We recommend considering stronger ciphers instead.

References MBEDTLS_CHECK_RETURN_TYPICAL, and MBEDTLS_DES_KEY_SIZE.